/****************************************************************************\
	FILE..........: tl30p_bc.h
  COPYRIGHT.....: Copyright(c) 1995, Bennet-Tec Information Systems, Inc
  VERSION.......: 3.99
	DESCRIPTION...: This source code is a supplement to the
									TList 3.0 VBX. (professional version)
\****************************************************************************/

#ifndef TL30P_BC_H
#define TL30P_BC_H

#include <owl\vbxctl.h>

//--------------------------------------------------------
// TList (VB1, subclassed from LISTBOX)
//--------------------------------------------------------
//
// Properties' constants
//
enum
{
  /* 0000 */ IPROP_TLIST_CTLNAME,
  /* 0001 */ IPROP_TLIST_INDEX, //not used
  /* 0002 */ IPROP_TLIST_TAG,
  /* 0003 */ IPROP_TLIST_LEFT,  //not used
  /* 0004 */ IPROP_TLIST_TOP,   //not used
  /* 0005 */ IPROP_TLIST_WIDTH, //not used
  /* 0006 */ IPROP_TLIST_HEIGHT,//not used
  /* 0007 */ IPROP_TLIST_FONTBOLD,
  /* 0008 */ IPROP_TLIST_FONTITALIC,
  /* 0009 */ IPROP_TLIST_FONTNAME,
  /* 0010 */ IPROP_TLIST_FONTSIZE,
  /* 0011 */ IPROP_TLIST_FONTSTRIKE,
  /* 0012 */ IPROP_TLIST_FONTUNDER,
  /* 0013 */ IPROP_TLIST_HWND,
  /* 0014 */ IPROP_TLIST_HELPCONTEXTID,//not used
  /* 0015 */ IPROP_TLIST_ALIGN,//not used
  /* 0016 */ IPROP_TLIST_FORECOLOR,
  /* 0017 */ IPROP_TLIST_BACKCOLOR,
  /* 0018 */ IPROP_TLIST_BORDERSTYLEON,
  /* 0019 */ IPROP_TLIST_DRAGICON,
  /* 0020 */ IPROP_TLIST_DRAGMODE,
	/* 0021 */ IPROP_TLIST_ENABLED,
  /* 0022 */ IPROP_TLIST_MOUSEPOINTER,
  /* 0023 */ IPROP_TLIST_TABINDEX, //not used
  /* 0024 */ IPROP_TLIST_VISIBLE,  //not used
  /* 0025 */ IPROP_TLIST_IMAGESTRETCH,
  /* 0026 */ IPROP_TLIST_ITEMHEIGHT,//obsolete
  /* 0027 */ IPROP_TLIST_INVSTYLE,
  /* 0028 */ IPROP_TLIST_VIEWSTYLE,
  /* 0029 */ IPROP_TLIST_SHIFTSTEP,
  /* 0030 */ IPROP_TLIST_IMAGEDEFHEIGHT,
  /* 0031 */ IPROP_TLIST_IMAGEDEFWIDTH,
  /* 0032 */ IPROP_TLIST_LISTCOUNT,
  /* 0033 */ IPROP_TLIST_LISTINDEX,
  /* 0034 */ IPROP_TLIST_REDRAW,
  /* 0035 */ IPROP_TLIST_ABOUT,
  /* 0036 */ IPROP_TLIST_MULTISELECT,
  /* 0037 */ IPROP_TLIST_SELECTED,
  /* 0038 */ IPROP_TLIST_LIST,
  /* 0039 */ IPROP_TLIST_IMAGE,
  /* 0040 */ IPROP_TLIST_INVIMAGE,
  /* 0041 */ IPROP_TLIST_ITEMBACKCOLOR,
  /* 0042 */ IPROP_TLIST_ITEMFORECOLOR,
	/* 0043 */ IPROP_TLIST_ITEMFONTNAME,
  /* 0044 */ IPROP_TLIST_ITEMFONTSIZE,
  /* 0045 */ IPROP_TLIST_ITEMFONTBOLD,
  /* 0046 */ IPROP_TLIST_ITEMFONTITALIC,
  /* 0047 */ IPROP_TLIST_ITEMFONTSTRIKE,
  /* 0048 */ IPROP_TLIST_ITEMFONTUNDER,
  /* 0049 */ IPROP_TLIST_SHIFT,
  /* 0050 */ IPROP_TLIST_FULLPATH,
  /* 0051 */ IPROP_TLIST_PICTURETYPE,
  /* 0052 */ IPROP_TLIST_EXPAND,
  /* 0053 */ IPROP_TLIST_PATHSEPARATOR,
  /* 0054 */ IPROP_TLIST_TOPINDEX,
  /* 0055 */ IPROP_TLIST_HASSUBITEMS,
  /* 0056 */ IPROP_TLIST_ISITEMVISIBLE,
  /* 0057 */ IPROP_TLIST_PICTUREROOT,
  /* 0058 */ IPROP_TLIST_PICTUREOPEN,
  /* 0059 */ IPROP_TLIST_PICTURECLOSED,
  /* 0060 */ IPROP_TLIST_PICTURELEAF,
  /* 0061 */ IPROP_TLIST_PICTUREINVERTED,
  /* 0062 */ IPROP_TLIST_CURINDEXMETHOD,
  /* 0063 */ IPROP_TLIST_SELFORECOLOR,
  /* 0064 */ IPROP_TLIST_SELBACKCOLOR,
	/* 0065 */ IPROP_TLIST_INSERTITEM,
  /* 0066 */ IPROP_TLIST_NOINTEGRALHEIGHT,
  /* 0067 */ IPROP_TLIST_DISABLENOSCROLL,
  /* 0068 */ IPROP_TLIST_WIDTHOFTEXT,
  /* 0069 */ IPROP_TLIST_ITEMMULTILINE,
  /* 0070 */ IPROP_TLIST_CURRENTITEM,
  /* 0071 */ IPROP_TLIST_DRAGHIGHLIGHT,
  /* 0072 */ IPROP_TLIST_SHOWCHILDREN,
  /* 0073 */ IPROP_TLIST_COERCEINDEX,
  /* 0074 */ IPROP_TLIST_DROPTARGET,
  /* 0075 */ IPROP_TLIST_ITEMTYPE,
  /* 0076 */ IPROP_TLIST_ITEMINTVALUE,
  /* 0077 */ IPROP_TLIST_ITEMLNGVALUE,
  /* 0078 */ IPROP_TLIST_ITEMSNGVALUE,
  /* 0079 */ IPROP_TLIST_ITEMSTRVALUE,
  /* 0080 */ IPROP_TLIST_ADD,
  /* 0081 */ IPROP_TLIST_INSERT,
  /* 0082 */ IPROP_TLIST_COPYITEM,
  /* 0083 */ IPROP_TLIST_COPYITEMSUB,
  /* 0084 */ IPROP_TLIST_COPYSELECTED,
  /* 0085 */ IPROP_TLIST_CLEARITEM,
  /* 0086 */ IPROP_TLIST_TABSTOP,
	/* 0087 */ IPROP_TLIST_PARENT,
  /* 0088 */ IPROP_TLIST_FIXEDSIZE,
  /* 0089 */ IPROP_TLIST_TABSTOPDISTANCE,
  /* 0090 */ IPROP_TLIST_90,
  /* 0091 */ IPROP_TLIST_ENVIRONMENT,
  /* 0092 */ IPROP_TLIST_DRAGEX,
  /* 0093 */ IPROP_TLIST_DRAGICONEX,
  /* 0094 */ IPROP_TLIST_SCROLLBARS,
  /* 0095 */ IPROP_TLIST_BOTTOMINDEX,
  /* 0096 */ IPROP_TLIST_SCROLLHORZ,
  /* 0097 */ IPROP_TLIST_ITEMEDITTEXT,
  /* 0098 */ IPROP_TLIST_LOADANDADD,
  /* 0099 */ IPROP_TLIST_LOADANDINSERT,
  /* 0100 */ IPROP_TLIST_SAVE,
  /* 0101 */ IPROP_TLIST_SAVESUB,
  /* 0102 */ IPROP_TLIST_ITEMPICVALUE,
  /* 0103 */ IPROP_TLIST_TEXT,
  /* 0104 */ IPROP_TLIST_CLIPBOARD,
  /* 0105 */ IPROP_TLIST_ISCLIPBOARDAVAILABLE,
  /* 0106 */ IPROP_TLIST_PICTUREPLUS,
	/* 0107 */ IPROP_TLIST_PICTUREMINUS,
  /* 0108 */ IPROP_TLIST_PICTUREMARK,
  /* 0109 */ IPROP_TLIST_AUTOSCRDURINGDRAGDROP,
  /* 0110 */ IPROP_TLIST_NOPICTUREROOT,
  /* 0111 */ IPROP_TLIST_VIEWSTYLEEX,
  /* 0112 */ IPROP_TLIST_ITEMMARK,
  /* 0113 */ IPROP_TLIST_MARKPICTURE,
  /* 0114 */ IPROP_TLIST_MARKTAG,
  /* 0115 */ IPROP_TLIST_MARKHEIGHT,
  /* 0116 */ IPROP_TLIST_MARKWIDTH,
  /* 0117 */ IPROP_TLIST_AUTOEXPAND,
  /* 0118 */ IPROP_TLIST_118,
  /* 0119 */ IPROP_TLIST_TREELINESSTYLE,
  /* 0120 */ IPROP_TLIST_PICINMULTILINE,
  /* 0121 */ IPROP_TLIST_SHOWCAPTION,
  /* 0122 */ IPROP_TLIST_CAPTION,
  /* 0123 */ IPROP_TLIST_SHOWTITLES,
  /* 0124 */ IPROP_TLIST_TITLEPICTURE,
  /* 0125 */ IPROP_TLIST_TITLETEXT,
  /* 0126 */ IPROP_TLIST_TITLEVISIBLE,
  /* 0127 */ IPROP_TLIST_TITLEWIDTH,
  /* 0128 */ IPROP_TLIST_TITLEHEIGHT,
	/* 0129 */ IPROP_TLIST_XOFFSET,
  /* 0130 */ IPROP_TLIST_INDENT,
  /* 0131 */ IPROP_TLIST_MSOUTLINEADD,
	/* 0132 */ IPROP_TLIST_LISTCOUNTEX,
	/* 0133 */ IPROP_TLIST_SELECTEX,
	/* 0134 */ IPROP_TLIST_EXPANDEX,
	/* 0135 */ IPROP_TLIST_SELITEMCOUNT,
	/* 0136 */ IPROP_TLIST_SELITEMINDEX,
	/* 0137 */ IPROP_TLIST_ITEMBM,
	/* 0138 */ IPROP_TLIST_CURRENTITEMBM,
	//
	/* 0139 */ IPROP_TLIST_NEWINDEX,
	/* 0140 */ IPROP_TLIST_BACKWARDCOMPATIBILITY,
	/* 0141 */ IPROP_TLIST_FILE,
	//
	/* 0142 */ IPROP_TLIST_EXPANDCHILDREN,
	/* 0143 */ IPROP_TLIST_EXPANDNEWITEM,
	//
	/* 0144 */ IPROP_TLIST_COPYONE,
	/* 0145 */ IPROP_TLIST_SAVEONE,
	//
	/* 0146 */ IPROP_TLIST_DRAGMODEEX,
	/* 0147 */ IPROP_TLIST_147,
	/* 0148 */ IPROP_TLIST_148,
	/* 0149 */ IPROP_TLIST_149,
	/* 0150 */ IPROP_TLIST_ITEMSORTED,
	/* 0151 */ IPROP_TLIST_ITEMPARENTBM,
	/* 0152 */ IPROP_TLIST_DEFMULTILINE,
	/* 0153 */ IPROP_TLIST_ITEMPMPICTYPE,
	/* 0154 */ IPROP_TLIST_WIDTHOFTEXTMIN,
  /* 0155 */ IPROP_TLIST_SMARTDRAGDROP
};

//
// Events' constants
//
enum
{
  /* 0000 */ IEVENT_TLIST_EXPAND,
  /* 0001 */ IEVENT_TLIST_COLLAPSE,
	/* 0002 */ IEVENT_TLIST_PICTURECLICK,
  /* 0003 */ IEVENT_TLIST_PICTUREDBLCLICK,
  /* 0004 */ IEVENT_TLIST_CLICK,
  /* 0005 */ IEVENT_TLIST_DBLCLICK,
  /* 0006 */ IEVENT_TLIST_KEYDOWN,
  /* 0007 */ IEVENT_TLIST_KEYUP,
  /* 0008 */ IEVENT_TLIST_KEYPRESS,
  /* 0009 */ IEVENT_TLIST_GOTFOCUS,
  /* 0010 */ IEVENT_TLIST_LOSTFOCUS,
  /* 0011 */ IEVENT_TLIST_MOUSEDOWN,
  /* 0012 */ IEVENT_TLIST_MOUSEMOVE,
  /* 0013 */ IEVENT_TLIST_MOUSEUP,
  /* 0014 */ IEVENT_TLIST_DRAGDROP,
  /* 0015 */ IEVENT_TLIST_DRAGOVER,

  /* 0016 */ IEVENT_TLIST_DRAGDROPEX,
  /* 0017 */ IEVENT_TLIST_DRAGOVEREX,
  /* 0018 */ IEVENT_TLIST_HSCROLL,
  /* 0019 */ IEVENT_TLIST_VSCROLL,
  /* 0020 */ IEVENT_TLIST_PLUSMINUSCLICK,
  /* 0021 */ IEVENT_TLIST_PLUSMINUSDBLCLICK,

	/* 0022 */ IEVENT_TLIST_MARKCLICK,
	/* 0023 */ IEVENT_TLIST_MARKDBLCLICK,
	/* 0024 */ IEVENT_TLIST_REQUESTEDITING,
	/* 0025 */ IEVENT_TLIST_AFTEREDITING,
	/* 0026 */ IEVENT_TLIST_EDITINGKEYDOWN,
	/* 0027 */ IEVENT_TLIST_EDITINGKEYUP,
	/* 0028 */ IEVENT_TLIST_EDITINGKEYPRESS,
};

DECLARE_HANDLE32(HTREEBUFFER);

class TVbxTList;

// TList functions declarations
extern "C"
VOID WINAPI TListFreeBuffer(HTREEBUFFER hTreeBuffer);

extern "C"
int  WINAPI TListIsValidBuffer(HTREEBUFFER hTreeBuffer);

//new functions for TList Pro version
extern "C"
int WINAPI TListTranslateIndex(TVbxTList* TListTree, int nFromIndexMethod,
                               int nToIndexMethod, int nFromIndex);
extern "C"
int WINAPI TListGetItemByXY(TVbxTList* TListTree, int nX, int nY, int nType);

extern "C"
int WINAPI TListGetItemRect(TVbxTList* TListTree, int nIndex, int nOpts,
                            LPRECT lpRectT);

extern "C"
int WINAPI TListSaveBuffer(HTREEBUFFER hTreeBuffer, int nFile);

extern "C"
int WINAPI TListLoadBuffer(HTREEBUFFER hTreeBuffer, int nFile);

extern "C"
int WINAPI TListCopyBuffer(HTREEBUFFER hTreeBuffer);

extern "C"
int WINAPI TListPasteBuffer(HTREEBUFFER hTreeBuffer);

extern "C"
int WINAPI TListIsClipboardFormatAvailable();

extern "C"
int WINAPI TListIndexByBM(TVbxTList* TListTree, LONG hTreeBookmark);

extern "C"
int WINAPI TListIsValidBM(TVbxTList* TListTree, LONG hTreeBookmark);

extern "C"
int WINAPI TListFindItem(TVbxTList* TListTree, LPSTR lpFindWhat,
                         int nFlags, int nFromIndex, int nToIndex);


// OWL class
class TVbxTList : public TVbxControl
{
	public:

		// constructors
		TVbxTList(TWindow* parent, int id, LPCSTR title,
				int x, int y, int w, int h,
				long initLen=0, void far* initData=0, TModule* module=0) :
      TVbxControl(parent, id, "TLISTPRO.VBX", "TList",
          title, x, y, w, h, initLen, initData, module) {}

    TVbxTList(TWindow* parent, int resourceId, TModule* module=0) :
        TVbxControl(parent, resourceId, module) {}

#if 0
    // event handlers
    void EvClick(VBXEVENT FAR*)
    {
      // no arguments
    }

		void EvCollapse(VBXEVENT FAR*)
    {
      // I As Integer
    }

		void EvDblClick(VBXEVENT FAR*)
    {
      // no arguments
    }

    void EvExpand(VBXEVENT FAR*)
    {
      // I As Integer
    }

    void EvGotFocus(VBXEVENT FAR*)
    {
      // no arguments
    }

    void EvKeyDown(VBXEVENT FAR*)
    {
			// KeyCode As Integer, Shift As Integer
    }

    void EvKeyPress(VBXEVENT FAR*)
    {
			// KeyAscii As Integer
    }

    void EvKeyUp(VBXEVENT FAR*)
    {
      // KeyCode As Integer, Shift As Integer
    }

    void EvLostFocus(VBXEVENT FAR*)
    {
      // no arguments
    }

    void EvMouseDown(VBXEVENT FAR*)
    {
      // Button As Integer,Shift As Integer,X As Integer,Y As Integer
    }

    void EvMouseMove(VBXEVENT FAR*)
    {
      // Button As Integer,Shift As Integer,X As Integer,Y As Integer
    }

    void EvMouseUp(VBXEVENT FAR*)
    {
      // Button As Integer,Shift As Integer,X As Integer,Y As Integer
    }

    void EvPictureClick(VBXEVENT FAR*)
    {
      // no arguments
    }

    void EvPictureDblClick(VBXEVENT FAR*)
    {
      // no arguments
    }

    void EvDragDropEx(VBXEVENT FAR*)
		{
      // hWnd As Integer, X As Integer, Y As Integer
    }

    void EvDragOverEx(VBXEVENT FAR*)
		{
      // hWnd As Integer, X As Integer, Y As Integer, State As Integer
    }

    void EvHScroll(VBXEVENT FAR*)
    {
      // CancelDefault As Integer, ScrollCode As Integer, Pos As Integer
    }

    void EvVScroll(VBXEVENT FAR*)
    {
      // CancelDefault As Integer, ScrollCode As Integer, Pos As Integer
    }

    void EvRequestEditing(VBXEVENT FAR*)
    {
      // Cancel As Integer, ItemIndex As Integer,TextToEdit As String, Options As Integer
		}

    void EvAfterEditing(VBXEVENT FAR*)
    {
      // ItemIndex As Integer, EditedText As String, CancelledBy As Integer
		}

    void EvEditingKeyDown(VBXEVENT FAR*)
    {
      // ItemIndex As Integer, KeyCode As Integer, Shift As Integer
    }

    void EvEditingKeyUp(VBXEVENT FAR*)
    {
      // ItemIndex As Integer, KeyCode As Integer, Shift As Integer
    }

    void EvEditingKeyPress(VBXEVENT FAR*)
    {
      // ItemIndex As Integer, KeyAscii As Integer
    }

#endif

    // enumerations
    enum { // values for property BorderStyle
      BorderStyle_0_None,
			BorderStyle_1_Fixed_Single,
    };

    enum { // values for property MousePointer
      MousePointer_0_Default,
      MousePointer_1_Arrow,
			MousePointer_2_Cross,
      MousePointer_3_IBeam,
      MousePointer_4_Icon,
      MousePointer_5_Size,
      MousePointer_6_Size_NE_SW,
      MousePointer_7_Size_NS,
      MousePointer_8_Size_NW_SE,
      MousePointer_9_Size_WE,
      MousePointer_10_Up_Arrow,
      MousePointer_11_Hourglass,
      MousePointer_12_No_Drop,
		};

    enum { // values for property InvStyle
      InvStyle_0_Text_Picture_Invertion,
      InvStyle_1_Picture_Invertion,
			InvStyle_2_Text_Invertion,
      InvStyle_3_All_Line_Invertion,
    };

    enum { // values for property ViewStyle
      ViewStyle_0_Picture_Text_Tree_lines,
			ViewStyle_1_Picture_Text,
      ViewStyle_2_Picture_Tree_lines,
      ViewStyle_3_Picture,
      ViewStyle_4_Text_Tree_lines,
      ViewStyle_5_Text,
    };

    enum { // values for property MultiSelect
      MultiSelect_0_None,
      MultiSelect_1_Simple,
      MultiSelect_2_Extended,
		};

    enum { // values for property PictureType
      PictureType_0_Solved,
			PictureType_1_Root_picture_always,
			PictureType_2_Open_picture_always,
      PictureType_3_Closed_picture_always,
      PictureType_4_Leaf_picture_always,
    };

    enum { // values for property CurrentIndexMethod
			CurrentIndexMethod_0_Enumerated_items,
      CurrentIndexMethod_1_Visible_items_only,
      CurrentIndexMethod_2_Changing_of_the_levels,
    };

    enum { // values for property DragEx
      DragEx_0_Cancel_drag_operation,
      DragEx_1_Begin_dragging,
      DragEx_2_End_dragging,
    };

		enum { // values for property Scrollbars
      Scrollbars_0_None,
      Scrollbars_1_Horizontal,
      Scrollbars_2_Vertical,
			Scrollbars_3_Both,
		};

    // TList's functions
    static  void              FreeBuffer     (HTREEBUFFER hTreeBuffer);
    static  int               IsValidBuffer  (HTREEBUFFER hTreeBuffer);
            int               TranslateIndex (int nFromIndexMethod,
                                              int nToIndexMethod,
                                              int nFromIndex);
            int               GetItemByXY    (int nX, int nY, int nType);
            int               GetItemRect    (int nIndex, int nOpts,
                                              LPRECT lpRectT);
    static  int               SaveBuffer     (HTREEBUFFER hTreeBuffer,
                                              int nFile);
    static  int               LoadBuffer     (HTREEBUFFER hTreeBuffer,
                                              int nFile);
    static  int               CopyBuffer     (HTREEBUFFER hTreeBuffer);
    static  int               PasteBuffer    (HTREEBUFFER hTreeBuffer);
    static  int               IsClipboardFormatAvailable
                                             ();
            int               IndexByBM      (LONG hTreeBookmark);
            int               IsValidBM      (LONG hTreeBookmark);
						int               FindItem       (LPSTR lpFindWhat, int nFlags,
																							int nFromIndex, int nToIndex);


    // TList's properties
    inline  BOOL              GetCtlName        (string &Name);
    inline  BOOL              SetCtlName        (string &Name);
    inline  BOOL              GetFontBold       (BOOL &bBold);
    inline  BOOL              SetFontBold       (BOOL bBold);
    inline  BOOL              GetFontItalic     (BOOL &bItalic);
    inline  BOOL              SetFontItalic     (BOOL bItalic);
    inline  BOOL              GetFontName       (string &);
    inline  BOOL              SetFontName       (string);
    inline  BOOL              GetFontSize       (int &);
    inline  BOOL              SetFontSize       (int);
    inline  BOOL              GetFontStrike     (BOOL &bStrike);
    inline  BOOL              SetFontStrike     (BOOL bStrike);
    inline  BOOL              GetFontUnder      (BOOL &bUnder);
    inline  BOOL              SetFontUnder      (BOOL bUnder);
    inline  BOOL              GetBackColor      (COLORREF &);
    inline  BOOL              SetBackColor      (COLORREF);
    inline  BOOL              GetForeColor      (COLORREF &);
    inline  BOOL              SetForeColor      (COLORREF);

    inline  BOOL              GetTag            (string &);
    inline  BOOL              SetTag            (string &);
    inline  BOOL              GetImageStretch   (BOOL &);
    inline  BOOL              SetImageStretch   (BOOL);
    inline  BOOL              GetInvStyle       (int &);
    inline  BOOL              SetInvStyle       (int);
    inline  BOOL              GetViewStyle      (int &);
    inline  BOOL              SetViewStyle      (int);
    inline  BOOL              GetShiftStep      (int &);
    inline  BOOL              SetShiftStep      (int);
    inline  BOOL              GetImageDefHeight (int &);
    inline  BOOL              SetImageDefHeight (int);
    inline  BOOL              GetImageDefWidth  (int &);
    inline  BOOL              SetImageDefWidth  (int);
    inline  BOOL              GetListCount      (int &);
		inline  BOOL              GetListIndex      (int &);
		inline  BOOL              SetListIndex      (int ListIndex);
    inline  BOOL              GetRedraw         (BOOL &);
    inline  BOOL              SetRedraw         (BOOL);
    inline  BOOL              GetMultiSelect    (int &);
    inline  BOOL              GetSelected       (BOOL &bSel, int nIndex);
    inline  BOOL              SetSelected       (BOOL bSel, int nIndex);
    inline  BOOL              GetList           (string &, int nIndex);
    inline  BOOL              SetList           (string &, int nIndex);
    inline  BOOL              GetImage          (HPIC &, int nIndex);
    inline  BOOL              SetImage          (HPIC, int nIndex);
    inline  HPIC              GetInvImage       (HPIC &, int nIndex);
    inline  BOOL              SetInvImage       (HPIC, int nIndex);
    inline  BOOL              GetItemBackColor  (COLORREF &, int nIndex);
    inline  BOOL              SetItemBackColor  (COLORREF, int nIndex);
    inline  BOOL              GetItemForeColor  (COLORREF &, int nIndex);
    inline  BOOL              SetItemForeColor  (COLORREF, int nIndex);
    inline  BOOL              GetItemFontName   (string &, int nIndex);
    inline  BOOL              SetItemFontName   (string &, int nIndex);
    inline  BOOL              GetItemFontBold   (BOOL &bBold, int nIndex);
    inline  BOOL              SetItemFontBold   (BOOL bBold, int nIndex);
    inline  BOOL              GetItemFontItalic (BOOL &bItalic, int nIndex);
		inline  BOOL              SetItemFontItalic (BOOL bItalic, int nIndex);
		inline  BOOL              GetItemFontStrike (BOOL &bStrike, int nIndex);
    inline  BOOL              SetItemFontStrike (BOOL bStrike, int nIndex);
    inline  BOOL              GetItemFontUnder  (BOOL &bUnder, int nIndex);
    inline  BOOL              SetItemFontUnder  (BOOL bUnder, int nIndex);
    inline  BOOL              GetShift          (int &nShift, int nIndex);
    inline  BOOL              SetShift          (int nShift, int nIndex);
    inline  BOOL              GetFullPath       (string &, int nIndex);
    inline  BOOL              GetPictureType    (int &);
    inline  BOOL              SetPictureType    (int nType);
    inline  BOOL              GetExpand         (BOOL &bExpand, int nIndex);
    inline  BOOL              SetExpand         (BOOL bExpand, int nIndex);
    inline  BOOL              GetPathSeparator  (string &);
    inline  BOOL              SetPathSeparator  (string &);
    inline  BOOL              GetTopIndex       (int &TopIndex);
    inline  BOOL              SetTopIndex       (int TopIndex);
    inline  BOOL              GetHasSubItems    (BOOL &, int nIndex);
    inline  BOOL              GetIsItemVisible  (BOOL &, int nIndex);
    inline  BOOL              GetPictureRoot    (HPIC &);
    inline  BOOL              SetPictureRoot    (HPIC);
    inline  BOOL              GetPictureOpen    (HPIC &);
    inline  BOOL              SetPictureOpen    (HPIC);
		inline  BOOL              GetPictureClosed  (HPIC &);
		inline  BOOL              SetPictureClosed  (HPIC);
    inline  BOOL              GetPictureLeaf    (HPIC &);
    inline  BOOL              SetPictureLeaf    (HPIC);
    inline  BOOL              GetPictureInverted(HPIC &);
    inline  BOOL              SetPictureInverted(HPIC);
    inline  BOOL              GetCurIndexMethod (int &nIndexMethod);
    inline  BOOL              SetCurIndexMethod (int nIndexMethod);
    inline  BOOL              GetSelForeColor   (COLORREF &);
    inline  BOOL              SetSelForeColor   (COLORREF);
    inline  BOOL              GetSelBackColor   (COLORREF &);
    inline  BOOL              SetSelBackColor   (COLORREF);
    inline  BOOL              SetInsertItem     (string &, int nIndex);
    inline  BOOL              GetNoIntegralHeight(BOOL &);
    inline  BOOL              GetDisableNoScroll(BOOL &);
    inline  BOOL              GetWidthOfText    (int &);
    inline  BOOL              SetWidthOfText    (int cxWidth);
    inline  BOOL              GetItemMultiLine  (BOOL &bMulti, int nIndex);
    inline  BOOL              SetItemMultiLine  (BOOL bMulti, int nIndex);
    inline  BOOL              GetCurrentItem    (string &);
    inline  BOOL              SetCurrentItem    (string &);
    inline  BOOL              GetDragHighLight  (int &);
		inline  BOOL              SetDragHighLight  (int);
		inline  BOOL              GetShowChildren   (BOOL &bShowChildren);
    inline  BOOL              SetShowChildren   (BOOL bShowChildren);
    inline  BOOL              GetCoerceIndex    (int EnumSystem, int &CoerceIndex);
    inline  BOOL              SetCoerceIndex    (int EnumSystem, int CoerceIndex);
    inline  BOOL              GetDropTarget     (int &);
    inline  BOOL              GetItemType       (int &, int nIndex);
    inline  BOOL              SetItemType       (int nType, int nIndex);
    inline  BOOL              GetItemIntValue   (int &nValue, int nIndex);
    inline  BOOL              SetItemIntValue   (int nValue, int nIndex);
    inline  BOOL              GetItemLngValue   (LONG &lValue, int nIndex);
    inline  BOOL              SetItemLngValue   (LONG lValue, int nIndex);
    inline  BOOL              GetItemSngValue   (float &, int nIndex);
    inline  BOOL              SetItemSngValue   (float, int nIndex);
    inline  BOOL              GetItemStrValue   (string &, int nIndex);
    inline  BOOL              SetItemStrValue   (string &, int nIndex);
    inline  BOOL              SetAdd            (HTREEBUFFER, int nIndex);
    inline  BOOL              SetInsert         (HTREEBUFFER, int nIndex);
    inline  BOOL              GetCopyItem       (HTREEBUFFER &, int nIndex);
    inline  BOOL              GetCopyItemSub    (HTREEBUFFER &, int nIndex);
		inline  BOOL              GetCopySelected   (HTREEBUFFER &);
    inline  BOOL              SetClearItem      (int nIndex);
		inline  BOOL              GetFixedSize      (BOOL &);
		inline  BOOL              GetTabStopDistance(int &nTabStopIndex);
    inline  BOOL              SetTabStopDistance(int nTabStopIndex);
    inline  BOOL              GetEnvironment    (int &flag);
		inline  BOOL              SetEnvironment    (int flag);
    inline  BOOL              SetDragEx         (int DragMode);
    inline  BOOL              GetDragIconEx     (HPIC &);
    inline  BOOL              SetDragIconEx     (HPIC);
    inline  BOOL              GetScrollBars     (int &);
    inline  BOOL              GetBottomIndex    (int &);
    inline  BOOL              GetScrollHorz     (int &);
    inline  BOOL              SetScrollHorz     (int);
    inline  BOOL              GetItemEditText   (BOOL &, int);
    inline  BOOL              SetLoadAndAdd     (int FileHandle, int nIndex);
    inline  BOOL              SetLoadAndInsert  (int FileHandle, int nIndex);
    inline  BOOL              SetSave           (int FileHandle, int nIndex);
    inline  BOOL              SetSaveSub        (int FileHandle, int nIndex);
    inline  BOOL              GetItemPicValue   (HPIC &);
    inline  BOOL              SetItemPicValue   (HPIC);
    inline  BOOL              GetText           (string &, int nIndex);
    inline  BOOL              SetText           (string &, int nIndex);
    inline  BOOL              SetClipboard      (int, int nIndex);
    inline  BOOL              GetIsClipboardAviable
																								(BOOL &, int nIndex);
		inline  BOOL              GetPicturePlus    (HPIC &);
    inline  BOOL              SetPicturePlus    (HPIC);
    inline  BOOL              GetPictureMinus   (HPIC &);
    inline  BOOL              SetPictureMinus   (HPIC);
    inline  BOOL              GetPictureMark    (HPIC &);
    inline  BOOL              SetPictureMark    (HPIC);
    inline  BOOL              GetAutoScrDuringDragDrop
                                                (BOOL &);
    inline  BOOL              SetAutoScrDuringDragDrop
                                                (int);
    inline  BOOL              SetNoPictureRoot  (BOOL);
    inline  BOOL              GetNoPictureRoot  (BOOL &);
    inline  BOOL              GetViewStyleEx    (int &);
    inline  BOOL              SetViewStyleEx    (int);
    inline  BOOL              GetItemMark       (int &MarkIndex, int nIndex);
    inline  BOOL              SetItemMark       (int MarkIndex, int nIndex);
    inline  BOOL              SetMarkPicture    (HPIC, int nIndex);
    inline  BOOL              GetMarkPicture    (HPIC &, int nIndex);
    inline  BOOL              SetMarkTag        (string &, int nIndex);
    inline  BOOL              GetMarkTag        (string &, int nIndex);
    inline  BOOL              SetMarkHeight     (LONG, int nIndex);
		inline  BOOL              GetMarkHeight     (LONG &, int nIndex);
		inline  BOOL              SetMarkWidth      (LONG, int nIndex);
    inline  BOOL              GetMarkWidth      (LONG &, int nIndex);
    inline  BOOL              SetAutoExpand     (int);
    inline  BOOL              GetAutoExpand     (int &);
    inline  BOOL              SetTreeLinesStyle (int);
    inline  BOOL              GetTreeLinesStyle (int &);

    inline  BOOL              SetPicInMultiLine (int);
    inline  BOOL              GetPicInMultiLine (int &);
    inline  BOOL              SetShowCaption    (int);
    inline  BOOL              GetShowCaption    (int &);
    inline  BOOL              SetCaption        (string &);
    inline  BOOL              GetCaption        (string &);
    inline  BOOL              SetShowTitles     (int);
    inline  BOOL              GetShowTitles     (int &);
    inline  BOOL              SetTitlePicture   (HPIC, int nIndex);
    inline  BOOL              GetTitlePicture   (HPIC &, int nIndex);
    inline  BOOL              SetTitleText      (string &, int nIndex);
    inline  BOOL              GetTitleText      (string &, int nIndex);
    inline  BOOL              SetTitleVisible   (int);
    inline  BOOL              GetTitleVisible   (int &);
    inline  BOOL              SetTitleWidth     (LONG , int nIndex);
    inline  BOOL              GetTitleWidth     (LONG &, int nIndex);
		inline  BOOL              SetTitleHeight    (LONG , int nIndex);
		inline  BOOL              GetTitleHeight    (LONG &, int nIndex);
    inline  BOOL              SetXOffset        (LONG);
    inline  BOOL              GetXOffset        (LONG &);
    inline  BOOL              SetIndent         (int, int nIndex);
    inline  BOOL              GetIndent         (int &, int nIndex);
    inline  BOOL              SetMSOutlineAdd   (BOOL);
    inline  BOOL              GetMSOutlineAdd   (BOOL &);
    inline  BOOL              GetListCountEx    (int &, int nIndex);
    inline  BOOL              SetSelectEx       (BOOL, int nIndex);
    inline  BOOL              SetExpandEx       (BOOL, int nIndex);
    inline  BOOL              GetSelItemCount   (int &ItemCount);
    inline  BOOL              GetSelItemIndex   (int &ItemIndex, int nIndex);
    inline  BOOL              GetItemBM         (LONG &, int nIndex);
    inline  BOOL              SetCurrentItemBM  (LONG, int nIndex);
    inline  BOOL              GetCurrentItemBM  (LONG &, int nIndex);
    inline  BOOL              GetNewIndex       (int &);
    inline  BOOL              SetBackwardCompatibility
                                                (BOOL);
    inline  BOOL              GetBackwardCompatibility
                                                (BOOL &);
    inline  BOOL              SetFile           (int Mode, int FileHandle);
		inline  BOOL              SetExpandChildren (BOOL);
		inline  BOOL              GetExpandChildren (BOOL &);

    inline  BOOL              SetExpandNewItem  (BOOL, int nIndex);
    inline  BOOL              GetExpandNewItem  (BOOL &, int nIndex);
    inline  BOOL              GetCopyOne        (LONG &Data, int nIndex);
    inline  BOOL              SetSaveOne        (int FileHandle, int nIndex);
    inline  BOOL              SetDragModeEx     (int Mode);
    inline  BOOL              GetDragModeEx     (int &Mode);
    inline  BOOL              SetItemSorted     (int SortMode, int nIndex);
    inline  BOOL              GetItemSorted     (int &SortMode, int nIndex);
    inline  BOOL              GetItemParentBM   (int Item, int nIndex);
    inline  BOOL              SetDefMultiLine   (BOOL TextMode, int nIndex);
    inline  BOOL              GetDefMultiLine   (BOOL &TextMode, int nIndex);
    inline  BOOL              SetItemPMPicType  (int PicType, int nIndex);
    inline  BOOL              GetItemPMPicType  (int &PicType, int nIndex);
    inline  BOOL              SetWidthOfTextMin (float Width);
    inline  BOOL              GetWidthOfTextMin (float & Width);
    inline  BOOL              SetSmartDragDrop  (BOOL Mode);
    inline  BOOL              GetSmartDragDrop  (BOOL & Mode);

		// special
		BOOL AddItem     (int nIndex, LPCSTR lpsz);
		BOOL Clear       ();
		BOOL SetProperty (int propIndex, LONG lData, int arrayIndex, int nVBType);
		BOOL GetProperty (int propIndex, LONG & lData, int arrayIndex, int nVBType);
		//
		BOOL GetProp     (int propIndex, ENUM & Data, int nIndex);
		BOOL GetProp     (int propIndex, int & Data, int nIndex);
		BOOL GetProp     (int propIndex, COLORREF & clrData, int nIndex);
		BOOL GetProp     (int propIndex, string & value, int arrayIndex);
		BOOL GetProp     (int propIndex, LONG & value, int arrayIndex);
		BOOL GetProp     (int propIndex, float & value, int arrayIndex);
		BOOL GetProp     (int propIndex, HPIC & value, int arrayIndex);
		//
		BOOL SetProp     (int propIndex, ENUM Data, int nIndex);
		BOOL SetProp     (int propIndex, int  Data, int nIndex);
		BOOL SetProp     (int propIndex, COLORREF clrData, int nIndex);
		BOOL SetProp     (int propIndex, string & value, int arrayIndex);
		BOOL SetProp     (int propIndex, LONG value, int arrayIndex);
		BOOL SetProp     (int propIndex, float value, int arrayIndex);
		BOOL SetProp     (int propIndex, HPIC  value, int arrayIndex);
		//

#if 0
	DECLARE_RESPONSE_TABLE(TVbxTList);
#endif
};

#if 0
// OWL response table
DEFINE_RESPONSE_TABLE1(TVbxTList, TVbxControl)
  EV_VBXEVENTINDEX( IDC_TList, Event_TList_Click, EvClick ),
  EV_VBXEVENTINDEX( IDC_TList, Event_TList_Collapse, EvCollapse ),
  EV_VBXEVENTINDEX( IDC_TList, Event_TList_DblClick, EvDblClick ),
  EV_VBXEVENTINDEX( IDC_TList, Event_TList_Expand, EvExpand ),
  EV_VBXEVENTINDEX( IDC_TList, Event_TList_GotFocus, EvGotFocus ),
  EV_VBXEVENTINDEX( IDC_TList, Event_TList_KeyDown, EvKeyDown ),
	EV_VBXEVENTINDEX( IDC_TList, Event_TList_KeyPress, EvKeyPress ),
  EV_VBXEVENTINDEX( IDC_TList, Event_TList_KeyUp, EvKeyUp ),
  EV_VBXEVENTINDEX( IDC_TList, Event_TList_LostFocus, EvLostFocus ),
  EV_VBXEVENTINDEX( IDC_TList, Event_TList_MouseDown, EvMouseDown ),
  EV_VBXEVENTINDEX( IDC_TList, Event_TList_MouseMove, EvMouseMove ),
  EV_VBXEVENTINDEX( IDC_TList, Event_TList_MouseUp, EvMouseUp ),
  EV_VBXEVENTINDEX( IDC_TList, Event_TList_PictureClick, EvPictureClick ),
	EV_VBXEVENTINDEX( IDC_TList, Event_TList_PictureDblClick, EvPictureDblClick ),
  EV_VBXEVENTINDEX( IDC_TList, Event_TList_DragDropEx, EvDragDropEx ),
  EV_VBXEVENTINDEX( IDC_TList, Event_TList_DragOverEx, EvDragOverEx ),
  EV_VBXEVENTINDEX( IDC_TList, Event_TList_HScroll, EvHScroll ),
  EV_VBXEVENTINDEX( IDC_TList, Event_TList_VScroll, EvVScroll ),
	EV_VBXEVENTINDEX( IDC_TList, Event_TList_RequestEditing, EvRequestEditing ),
	EV_VBXEVENTINDEX( IDC_TList, Event_TList_AfterEditing, EvAfterEditing ),
	EV_VBXEVENTINDEX( IDC_TList, Event_TList_EditingKeyDown, EvEditingKeyDown ),
	EV_VBXEVENTINDEX( IDC_TList, Event_TList_EditingKeyUp, EvEditingKeyUp ),
	EV_VBXEVENTINDEX( IDC_TList, Event_TList_EditingKeyPress, EvEditingKeyPress ),
END_RESPONSE_TABLE;
#endif

//
inline BOOL TVbxTList::SetProp(int propIndex, ENUM Data, int arrayIndex)
{ return SetProperty(propIndex, LONG(Data), arrayIndex, PTYPE_ENUM); }

inline BOOL TVbxTList::SetProp(int propIndex, int  Data, int arrayIndex)
{ return SetProperty(propIndex, LONG(Data), arrayIndex, PTYPE_SHORT); }

inline BOOL TVbxTList::SetProp(int propIndex, COLORREF clrData, int arrayIndex)
{ return SetProperty(propIndex, LONG(clrData), arrayIndex, PTYPE_COLOR); }

inline BOOL TVbxTList::SetProp(int propIndex, string & value, int arrayIndex)
{ return SetProperty(propIndex, LONG(value.c_str()), arrayIndex, PTYPE_CSTRING); }

inline BOOL TVbxTList::SetProp(int propIndex, LONG value, int arrayIndex)
{ return SetProperty(propIndex, value, arrayIndex, PTYPE_LONG); }

inline BOOL TVbxTList::SetProp(int propIndex, float value, int arrayIndex)
{ return SetProperty(propIndex, *(LONG *)&value, arrayIndex, PTYPE_REAL);}

inline BOOL TVbxTList::SetProp(int propIndex, HPIC value, int arrayIndex)
{ return SetProperty(propIndex, LONG(value), arrayIndex, PTYPE_PICTURE); }

inline  BOOL TVbxTList::GetCtlName(string &Name)
{ return TVbxControl::GetProp(IPROP_TLIST_CTLNAME, Name);}

inline  BOOL TVbxTList::SetCtlName(string &Name)
{ return TVbxControl::SetProp(IPROP_TLIST_CTLNAME, Name);}

inline  BOOL TVbxTList::GetFontBold(BOOL &bBold)
{ return TVbxControl::GetProp(IPROP_TLIST_FONTBOLD, bBold);}

inline  BOOL TVbxTList::SetFontBold(BOOL bBold)
{ return TVbxControl::SetProp(IPROP_TLIST_FONTBOLD, bBold);}

inline  BOOL TVbxTList::GetFontItalic(BOOL &bItalic)
{ return TVbxControl::GetProp(IPROP_TLIST_FONTITALIC, bItalic);}

inline  BOOL TVbxTList::SetFontItalic(BOOL bItalic)
{ return TVbxControl::SetProp(IPROP_TLIST_FONTITALIC, bItalic);}

inline  BOOL TVbxTList::GetFontName(string &Name)
{ return TVbxControl::GetProp(IPROP_TLIST_FONTNAME, Name);}

inline  BOOL TVbxTList::SetFontName(string Name)
{ return TVbxControl::SetProp(IPROP_TLIST_FONTNAME, Name);}

inline  BOOL TVbxTList::GetFontSize(int &Size)
{ return TVbxControl::GetProp(IPROP_TLIST_FONTSIZE, Size);}

inline  BOOL TVbxTList::SetFontSize(int Size)
{ return TVbxControl::SetProp(IPROP_TLIST_FONTSIZE, Size);}

inline  BOOL TVbxTList::GetFontStrike(BOOL &bStrike)
{ return TVbxControl::GetProp(IPROP_TLIST_FONTSTRIKE, bStrike);}

inline  BOOL TVbxTList::SetFontStrike(BOOL bStrike)
{ return TVbxControl::SetProp(IPROP_TLIST_FONTSTRIKE, bStrike);}

inline  BOOL TVbxTList::GetFontUnder(BOOL &bUnder)
{ return TVbxControl::GetProp(IPROP_TLIST_FONTUNDER, bUnder);}

inline  BOOL TVbxTList::SetFontUnder(BOOL bUnder)
{ return TVbxControl::SetProp(IPROP_TLIST_FONTUNDER, bUnder);}

inline  BOOL TVbxTList::GetBackColor(COLORREF &color)
{ return TVbxControl::GetProp(IPROP_TLIST_BACKCOLOR, color);}

inline  BOOL TVbxTList::SetBackColor(COLORREF color)
{ return TVbxControl::SetProp(IPROP_TLIST_BACKCOLOR, color);}

inline  BOOL TVbxTList::GetForeColor(COLORREF &color)
{ return TVbxControl::GetProp(IPROP_TLIST_FORECOLOR, color);}

inline  BOOL TVbxTList::SetForeColor(COLORREF color)
{ return TVbxControl::SetProp(IPROP_TLIST_FORECOLOR, color);}

inline  BOOL TVbxTList::GetTag(string &str)
{ return TVbxControl::GetProp(IPROP_TLIST_TAG, str);}

inline  BOOL TVbxTList::SetTag(string &str)
{ return TVbxControl::SetProp(IPROP_TLIST_TAG, str);}

inline  BOOL TVbxTList::GetImageStretch(BOOL &bStretch)
{ return TVbxControl::GetProp(IPROP_TLIST_IMAGESTRETCH, bStretch);}

inline  BOOL TVbxTList::SetImageStretch(BOOL bStretch)
{ return TVbxControl::SetProp(IPROP_TLIST_IMAGESTRETCH, bStretch);}

inline  BOOL TVbxTList::GetInvStyle(int &Style)
{ return TVbxControl::GetProp(IPROP_TLIST_INVSTYLE, Style);}

inline  BOOL TVbxTList::SetInvStyle(int Style)
{ return TVbxControl::SetProp(IPROP_TLIST_INVSTYLE, Style);}

inline  BOOL TVbxTList::GetViewStyle(int &Style)
{ return TVbxControl::GetProp(IPROP_TLIST_VIEWSTYLE, Style);}

inline  BOOL TVbxTList::SetViewStyle(int Style)
{ return TVbxControl::SetProp(IPROP_TLIST_VIEWSTYLE, Style);}

inline  BOOL TVbxTList::GetShiftStep(int &ShiftStep)
{ return TVbxControl::GetProp(IPROP_TLIST_SHIFTSTEP, ShiftStep);}

inline  BOOL TVbxTList::SetShiftStep(int ShiftStep)
{ return TVbxControl::SetProp(IPROP_TLIST_SHIFTSTEP, ShiftStep);}

inline  BOOL TVbxTList::GetImageDefHeight(int &Height)
{ return TVbxControl::GetProp(IPROP_TLIST_IMAGEDEFHEIGHT, Height);}

inline  BOOL TVbxTList::SetImageDefHeight(int Height)
{ return TVbxControl::SetProp(IPROP_TLIST_IMAGEDEFHEIGHT, Height);}

inline  BOOL TVbxTList::GetImageDefWidth(int &Width)
{ return TVbxControl::GetProp(IPROP_TLIST_IMAGEDEFWIDTH, Width);}

inline  BOOL TVbxTList::SetImageDefWidth(int Width)
{ return TVbxControl::SetProp(IPROP_TLIST_IMAGEDEFWIDTH, Width);}

inline  BOOL TVbxTList::GetListCount(int &Count)
{ return TVbxControl::GetProp(IPROP_TLIST_LISTCOUNT, Count);}

inline  BOOL TVbxTList::GetListIndex(int &ListIndex)
{ return TVbxControl::GetProp(IPROP_TLIST_LISTINDEX, ListIndex);}

inline  BOOL TVbxTList::SetListIndex(int ListIndex)
{ return TVbxControl::SetProp(IPROP_TLIST_LISTINDEX, ListIndex);}

inline  BOOL TVbxTList::GetRedraw(BOOL &Redraw)
{ return TVbxControl::GetProp(IPROP_TLIST_REDRAW, Redraw);}

inline  BOOL TVbxTList::SetRedraw(BOOL Redraw)
{ return TVbxControl::SetProp(IPROP_TLIST_REDRAW, Redraw);}

inline  BOOL TVbxTList::GetMultiSelect(int &Select)
{ return TVbxControl::GetProp(IPROP_TLIST_MULTISELECT, Select);}

inline  BOOL TVbxTList::GetSelected(BOOL &bSel, int nIndex)
{ return GetProp(IPROP_TLIST_SELECTED, bSel, nIndex);}

inline  BOOL TVbxTList::SetSelected(BOOL bSel, int nIndex)
{ return SetProp(IPROP_TLIST_SELECTED, bSel, nIndex);}

inline  BOOL TVbxTList::GetList(string &str, int nIndex)
{ return GetProp(IPROP_TLIST_LIST, str, nIndex);}

inline  BOOL TVbxTList::SetList(string &str, int nIndex)
{ return SetProp(IPROP_TLIST_LIST, str, nIndex);}

inline  BOOL TVbxTList::GetImage(HPIC &pict, int nIndex)
{ return GetProp(IPROP_TLIST_IMAGE, pict, nIndex);}

inline  BOOL TVbxTList::SetImage(HPIC pict, int nIndex)
{ return SetProp(IPROP_TLIST_IMAGE, pict, nIndex);}

inline  HPIC TVbxTList::GetInvImage(HPIC &pict, int nIndex)
{ return GetProp(IPROP_TLIST_INVIMAGE, pict, nIndex);}

inline  BOOL TVbxTList::SetInvImage(HPIC pict, int nIndex)
{ return GetProp(IPROP_TLIST_INVIMAGE, pict, nIndex);}

inline  BOOL TVbxTList::GetItemBackColor(COLORREF &color, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMBACKCOLOR, color, nIndex);}

inline  BOOL TVbxTList::SetItemBackColor(COLORREF color, int nIndex)
{ return SetProp(IPROP_TLIST_ITEMBACKCOLOR, color, nIndex);}

inline  BOOL TVbxTList::GetItemForeColor(COLORREF &color, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMFORECOLOR, color, nIndex);}

inline  BOOL TVbxTList::SetItemForeColor(COLORREF color, int nIndex)
{ return SetProp(IPROP_TLIST_ITEMFORECOLOR, color, nIndex);}

inline  BOOL TVbxTList::GetItemFontName(string &FontName, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMFONTNAME, FontName, nIndex);}

inline  BOOL TVbxTList::SetItemFontName(string &FontName, int nIndex)
{ return SetProp(IPROP_TLIST_ITEMFONTNAME, FontName, nIndex);}

inline  BOOL TVbxTList::GetItemFontBold(BOOL &bBold, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMFONTBOLD, bBold, nIndex);}

inline  BOOL TVbxTList::SetItemFontBold(BOOL bBold, int nIndex)
{ return SetProp(IPROP_TLIST_ITEMFONTBOLD, bBold, nIndex);}

inline  BOOL TVbxTList::GetItemFontItalic(BOOL &bItalic, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMFONTITALIC, bItalic, nIndex);}

inline  BOOL TVbxTList::SetItemFontItalic(BOOL bItalic, int nIndex)
{ return SetProp(IPROP_TLIST_ITEMFONTITALIC, bItalic, nIndex);}

inline  BOOL TVbxTList::GetItemFontStrike(BOOL &bStrike, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMFONTSTRIKE, bStrike, nIndex);}

inline  BOOL TVbxTList::SetItemFontStrike(BOOL bStrike, int nIndex)
{ return SetProp(IPROP_TLIST_ITEMFONTSTRIKE, bStrike, nIndex);}

inline  BOOL TVbxTList::GetItemFontUnder(BOOL &bUnder, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMFONTSTRIKE, bUnder, nIndex);}

inline  BOOL TVbxTList::SetItemFontUnder(BOOL bUnder, int nIndex)
{ return SetProp(IPROP_TLIST_ITEMFONTSTRIKE, bUnder, nIndex);}

inline  BOOL TVbxTList::GetShift(int &nShift, int nIndex)
{ return GetProp(IPROP_TLIST_SHIFT, nShift, nIndex);}

inline  BOOL TVbxTList::SetShift(int nShift, int nIndex)
{ return SetProp(IPROP_TLIST_SHIFT, nShift, nIndex);}

inline  BOOL TVbxTList::GetFullPath(string &Path, int nIndex)
{ return GetProp(IPROP_TLIST_FULLPATH, Path, nIndex);}

inline  BOOL TVbxTList::GetPictureType(int &PicType)
{ return TVbxControl::GetProp(IPROP_TLIST_PICTURETYPE, PicType);}

inline  BOOL TVbxTList::SetPictureType(int PicType)
{ return TVbxControl::SetProp(IPROP_TLIST_PICTURETYPE, PicType);}

inline  BOOL TVbxTList::GetExpand(BOOL &bExpand, int nIndex)
{ return GetProp(IPROP_TLIST_EXPAND, bExpand, nIndex);}

inline  BOOL TVbxTList::SetExpand(BOOL bExpand, int nIndex)
{ return SetProp(IPROP_TLIST_EXPAND, bExpand, nIndex);}

inline  BOOL TVbxTList::GetPathSeparator(string &Separator)
{ return TVbxControl::GetProp(IPROP_TLIST_PATHSEPARATOR, Separator);}

inline  BOOL TVbxTList::SetPathSeparator(string &Separator)
{ return TVbxControl::SetProp(IPROP_TLIST_PATHSEPARATOR, Separator);}

inline  BOOL TVbxTList::GetTopIndex(int &TopIndex)
{ return TVbxControl::GetProp(IPROP_TLIST_TOPINDEX, TopIndex);}

inline  BOOL TVbxTList::SetTopIndex(int TopIndex)
{ return TVbxControl::SetProp(IPROP_TLIST_TOPINDEX, TopIndex);}

inline  BOOL TVbxTList::GetHasSubItems(BOOL &flag, int nIndex)
{ return GetProp(IPROP_TLIST_HASSUBITEMS, flag, nIndex);}

inline  BOOL TVbxTList::GetIsItemVisible(BOOL &flag, int nIndex)
{ return GetProp(IPROP_TLIST_ISITEMVISIBLE, flag, nIndex);}

inline  BOOL TVbxTList::GetPictureRoot(HPIC &pict)
{ return TVbxControl::GetProp(IPROP_TLIST_PICTUREROOT, pict);}

inline  BOOL TVbxTList::SetPictureRoot(HPIC pict)
{ return TVbxControl::SetProp(IPROP_TLIST_PICTUREROOT, pict);}

inline  BOOL TVbxTList::GetPictureOpen(HPIC &pict)
{ return TVbxControl::GetProp(IPROP_TLIST_PICTUREOPEN, pict);}

inline  BOOL TVbxTList::SetPictureOpen(HPIC pict)
{ return TVbxControl::SetProp(IPROP_TLIST_PICTUREOPEN, pict);}

inline  BOOL TVbxTList::GetPictureClosed(HPIC &pict)
{ return TVbxControl::GetProp(IPROP_TLIST_PICTURECLOSED, pict);}

inline  BOOL TVbxTList::SetPictureClosed(HPIC pict)
{ return TVbxControl::SetProp(IPROP_TLIST_PICTURECLOSED, pict);}

inline  BOOL TVbxTList::GetPictureLeaf(HPIC &pict)
{ return TVbxControl::GetProp(IPROP_TLIST_PICTURELEAF, pict);}

inline  BOOL TVbxTList::SetPictureLeaf(HPIC pict)
{ return TVbxControl::SetProp(IPROP_TLIST_PICTURELEAF, pict);}

inline  BOOL TVbxTList::GetPictureInverted(HPIC &pict)
{ return TVbxControl::GetProp(IPROP_TLIST_PICTUREINVERTED, pict);}

inline  BOOL TVbxTList::SetPictureInverted(HPIC pict)
{ return TVbxControl::SetProp(IPROP_TLIST_PICTUREINVERTED, pict);}

inline  BOOL TVbxTList::GetCurIndexMethod(int &nIndexMethod)
{ return TVbxControl::GetProp(IPROP_TLIST_CURINDEXMETHOD, nIndexMethod);}

inline  BOOL TVbxTList::SetCurIndexMethod(int nIndexMethod)
{ return TVbxControl::SetProp(IPROP_TLIST_CURINDEXMETHOD, nIndexMethod);}

inline  BOOL TVbxTList::GetSelForeColor(COLORREF &color)
{ return TVbxControl::GetProp(IPROP_TLIST_SELFORECOLOR, color);}

inline  BOOL TVbxTList::SetSelForeColor(COLORREF color)
{ return TVbxControl::SetProp(IPROP_TLIST_SELFORECOLOR, color);}

inline  BOOL TVbxTList::GetSelBackColor(COLORREF &color)
{ return TVbxControl::GetProp(IPROP_TLIST_SELBACKCOLOR, color);}

inline  BOOL TVbxTList::SetSelBackColor(COLORREF color)
{ return TVbxControl::SetProp(IPROP_TLIST_SELBACKCOLOR, color);}

inline  BOOL TVbxTList::SetInsertItem(string &str, int nIndex)
{ return TVbxControl::SetProp(IPROP_TLIST_INSERTITEM, str, nIndex);}

inline  BOOL TVbxTList::GetNoIntegralHeight(BOOL &flag)
{ return TVbxControl::GetProp(IPROP_TLIST_NOINTEGRALHEIGHT, flag);}

inline  BOOL TVbxTList::GetDisableNoScroll(BOOL &flag)
{ return TVbxControl::GetProp(IPROP_TLIST_DISABLENOSCROLL, flag);}

inline  BOOL TVbxTList::GetWidthOfText(int &Width)
{ return TVbxControl::GetProp(IPROP_TLIST_WIDTHOFTEXT, Width);}

inline  BOOL TVbxTList::SetWidthOfText(int Width)
{ return TVbxControl::SetProp(IPROP_TLIST_WIDTHOFTEXT, Width);}

inline  BOOL TVbxTList::GetItemMultiLine(BOOL &bMulti, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMMULTILINE, bMulti, nIndex);}

inline  BOOL TVbxTList::SetItemMultiLine(BOOL bMulti, int nIndex)
{ return SetProp(IPROP_TLIST_ITEMMULTILINE, bMulti, nIndex);}

inline  BOOL TVbxTList::GetCurrentItem(string &str)
{ return TVbxControl::GetProp(IPROP_TLIST_CURRENTITEM, str);}

inline  BOOL TVbxTList::SetCurrentItem(string &str)
{ return TVbxControl::SetProp(IPROP_TLIST_CURRENTITEM, str);}

inline  BOOL TVbxTList::GetDragHighLight(int &HighLight)
{ return TVbxControl::GetProp(IPROP_TLIST_DRAGHIGHLIGHT, HighLight);}

inline  BOOL TVbxTList::SetDragHighLight(int HighLight)
{ return TVbxControl::SetProp(IPROP_TLIST_DRAGHIGHLIGHT, HighLight);}

inline  BOOL TVbxTList::GetShowChildren(BOOL &bShowChildren)
{ return TVbxControl::GetProp(IPROP_TLIST_SHOWCHILDREN, bShowChildren);}

inline  BOOL TVbxTList::SetShowChildren(BOOL bShowChildren)
{ return TVbxControl::SetProp(IPROP_TLIST_SHOWCHILDREN, bShowChildren);}

inline  BOOL TVbxTList::GetCoerceIndex(int EnumSystem, int &CoerceIndex)
{ return GetProp(IPROP_TLIST_COERCEINDEX, EnumSystem, CoerceIndex);}

inline  BOOL TVbxTList::SetCoerceIndex(int EnumSystem, int CoerceIndex)
{ return SetProp(IPROP_TLIST_COERCEINDEX, EnumSystem, CoerceIndex);}

inline  BOOL TVbxTList::GetDropTarget(int &flag)
{ return TVbxControl::GetProp(IPROP_TLIST_DROPTARGET, flag); }

inline  BOOL TVbxTList::GetItemType(int &ItemType, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMTYPE, ItemType, nIndex);}

inline  BOOL TVbxTList::SetItemType(int ItemType, int nIndex)
{ return SetProp(IPROP_TLIST_ITEMTYPE, ItemType, nIndex);}

inline  BOOL TVbxTList::GetItemIntValue(int &nValue, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMINTVALUE, nValue, nIndex);}

inline  BOOL TVbxTList::SetItemIntValue(int nValue, int nIndex)
{ return SetProp(IPROP_TLIST_ITEMINTVALUE, nValue, nIndex);}

inline  BOOL TVbxTList::GetItemLngValue(LONG &lValue, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMLNGVALUE, lValue, nIndex);}

inline  BOOL TVbxTList::SetItemLngValue(LONG lValue, int nIndex)
{ return SetProp(IPROP_TLIST_ITEMLNGVALUE, lValue, nIndex);}

inline  BOOL TVbxTList::GetItemSngValue(float &nValue, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMSNGVALUE, nValue, nIndex);}

inline  BOOL TVbxTList::SetItemSngValue(float nValue, int nIndex)
{ return SetProp(IPROP_TLIST_ITEMSNGVALUE, nValue, nIndex);}

inline  BOOL TVbxTList::GetItemStrValue(string &str, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMSTRVALUE, str, nIndex);}

inline  BOOL TVbxTList::SetItemStrValue(string &str, int nIndex)
{ return SetProp(IPROP_TLIST_ITEMSTRVALUE, str, nIndex);}

inline  BOOL TVbxTList::SetAdd(HTREEBUFFER htr, int nIndex)
{ return SetProp(IPROP_TLIST_ADD, LONG(htr), nIndex);}

inline  BOOL TVbxTList::SetInsert(HTREEBUFFER htr, int nIndex)
{ return SetProp(IPROP_TLIST_INSERT, LONG(htr), nIndex);}

inline  BOOL TVbxTList::GetCopyItem(HTREEBUFFER &htr, int nIndex)
{ return GetProp(IPROP_TLIST_COPYITEM, LONG(htr), nIndex);}

inline  BOOL TVbxTList::GetCopyItemSub(HTREEBUFFER &htr, int nIndex)
{ return GetProp(IPROP_TLIST_COPYITEMSUB, LONG(htr), nIndex);}

inline  BOOL TVbxTList::GetCopySelected(HTREEBUFFER &htr)
{ return TVbxControl::GetProp(IPROP_TLIST_COPYSELECTED, LONG(htr));}

inline  BOOL TVbxTList::SetClearItem(int ClearIndex)
{ return TVbxControl::SetProp(IPROP_TLIST_CLEARITEM, ClearIndex);}

inline  BOOL TVbxTList::GetFixedSize(BOOL &FixedSize)
{ return TVbxControl::GetProp(IPROP_TLIST_FIXEDSIZE, FixedSize);}

inline  BOOL TVbxTList::GetTabStopDistance(int &nTabStopIndex)
{ return TVbxControl::GetProp(IPROP_TLIST_TABSTOPDISTANCE, nTabStopIndex);}

inline  BOOL TVbxTList::SetTabStopDistance(int nTabStopIndex)
{ return TVbxControl::SetProp(IPROP_TLIST_TABSTOPDISTANCE, nTabStopIndex);}

inline  BOOL TVbxTList::GetEnvironment(int &flag)
{ return TVbxControl::GetProp(IPROP_TLIST_ENVIRONMENT, flag);}

inline  BOOL TVbxTList::SetEnvironment(int flag)
{ return TVbxControl::SetProp(IPROP_TLIST_ENVIRONMENT, flag);}

// from here on only for TList Pro version.
inline  BOOL TVbxTList::SetDragEx(int DragMode)
{ return TVbxControl::SetProp(IPROP_TLIST_DRAGEX, DragMode); }

inline  BOOL TVbxTList::GetDragIconEx(HPIC &pict)
{ return TVbxControl::GetProp(IPROP_TLIST_DRAGICONEX, pict);}

inline  BOOL TVbxTList::SetDragIconEx(HPIC pict)
{ return TVbxControl::SetProp(IPROP_TLIST_DRAGICONEX, pict);}

inline  BOOL TVbxTList::GetScrollBars(int &flag)
{ return TVbxControl::GetProp(IPROP_TLIST_SCROLLBARS, flag);}

inline  BOOL TVbxTList::GetBottomIndex(int &BottIndex)
{ return TVbxControl::GetProp(IPROP_TLIST_BOTTOMINDEX, BottIndex);}

inline  BOOL TVbxTList::GetScrollHorz(int &Scroll)
{ return TVbxControl::GetProp(IPROP_TLIST_SCROLLHORZ, Scroll);}

inline  BOOL TVbxTList::SetScrollHorz(int Scroll)
{ return TVbxControl::SetProp(IPROP_TLIST_SCROLLHORZ, Scroll);}

inline  BOOL TVbxTList::GetItemEditText(BOOL &flag, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMEDITTEXT, flag, nIndex);}

inline  BOOL TVbxTList::SetLoadAndAdd(int FileHandle, int nIndex)
{ return SetProp(IPROP_TLIST_LOADANDADD, FileHandle, nIndex);}

inline  BOOL TVbxTList::SetLoadAndInsert(int FileHandle, int nIndex)
{ return SetProp(IPROP_TLIST_LOADANDINSERT, FileHandle, nIndex);}

inline  BOOL TVbxTList::SetSave(int FileHandle, int nIndex)
{ return SetProp(IPROP_TLIST_SAVE, FileHandle, nIndex);}

inline  BOOL TVbxTList::SetSaveSub(int FileHandle, int nIndex)
{ return SetProp(IPROP_TLIST_SAVESUB, FileHandle, nIndex);}

inline  BOOL TVbxTList::GetItemPicValue(HPIC &pict)
{ return TVbxControl::GetProp(IPROP_TLIST_ITEMPICVALUE, pict);}

inline  BOOL TVbxTList::SetItemPicValue(HPIC pict)
{ return TVbxControl::SetProp(IPROP_TLIST_ITEMPICVALUE, pict);}

inline  BOOL TVbxTList::GetText(string &str, int nIndex)
{ return GetProp(IPROP_TLIST_TEXT, str, nIndex);}

inline  BOOL TVbxTList::SetText(string &str, int nIndex)
{ return SetProp(IPROP_TLIST_TEXT, str, nIndex);}

inline  BOOL TVbxTList::SetClipboard(int Mode, int nIndex)
{ return SetProp(IPROP_TLIST_CLIPBOARD, Mode, nIndex);}

inline  BOOL TVbxTList::GetIsClipboardAviable(BOOL &flag, int nIndex)
{ return GetProp(IPROP_TLIST_ISCLIPBOARDAVAILABLE, flag, nIndex);}

inline  BOOL TVbxTList::GetPicturePlus(HPIC &pict)
{ return TVbxControl::GetProp(IPROP_TLIST_PICTUREPLUS, pict);}

inline  BOOL TVbxTList::SetPicturePlus(HPIC pict)
{ return TVbxControl::SetProp(IPROP_TLIST_PICTUREPLUS, pict);}

inline  BOOL TVbxTList::GetPictureMinus(HPIC &pict)
{ return TVbxControl::GetProp(IPROP_TLIST_PICTUREMINUS, pict);}

inline  BOOL TVbxTList::SetPictureMinus(HPIC pict)
{ return TVbxControl::SetProp(IPROP_TLIST_PICTUREMINUS,  pict);}

inline  BOOL TVbxTList::GetPictureMark(HPIC &pict)
{ return TVbxControl::GetProp(IPROP_TLIST_PICTUREMARK, pict);}

inline  BOOL TVbxTList::SetPictureMark(HPIC pict)
{ return TVbxControl::SetProp(IPROP_TLIST_PICTUREMARK, pict);}

inline  BOOL TVbxTList::GetAutoScrDuringDragDrop(BOOL &flag)
{ return TVbxControl::GetProp(IPROP_TLIST_AUTOSCRDURINGDRAGDROP, flag);}

inline  BOOL TVbxTList::SetAutoScrDuringDragDrop(int flag)
{ return TVbxControl::SetProp(IPROP_TLIST_AUTOSCRDURINGDRAGDROP, flag);}

inline  BOOL TVbxTList::GetNoPictureRoot(BOOL &flag)
{ return TVbxControl::GetProp(IPROP_TLIST_NOPICTUREROOT, flag);}

inline  BOOL TVbxTList::SetNoPictureRoot(BOOL flag)
{ return TVbxControl::SetProp(IPROP_TLIST_NOPICTUREROOT, flag);}

inline  BOOL TVbxTList::GetViewStyleEx(int &Style)
{ return TVbxControl::GetProp(IPROP_TLIST_VIEWSTYLEEX, Style);}

inline  BOOL TVbxTList::SetViewStyleEx(int Style)
{ return TVbxControl::SetProp(IPROP_TLIST_VIEWSTYLEEX, Style);}

inline  BOOL TVbxTList::GetItemMark(int &MarkIndex, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMMARK, MarkIndex, nIndex);}

inline  BOOL TVbxTList::SetItemMark(int MarkIndex, int nIndex)
{ return SetProp(IPROP_TLIST_ITEMMARK, MarkIndex, nIndex);}

inline  BOOL TVbxTList::GetMarkPicture(HPIC &pict, int nIndex)
{ return GetProp(IPROP_TLIST_MARKPICTURE, pict, nIndex);}

inline  BOOL TVbxTList::SetMarkPicture(HPIC pict, int nIndex)
{ return SetProp(IPROP_TLIST_MARKPICTURE, pict, nIndex);}

inline  BOOL TVbxTList::GetMarkTag(string &Tag, int nIndex)
{ return GetProp(IPROP_TLIST_MARKTAG, Tag, nIndex);}

inline  BOOL TVbxTList::SetMarkTag(string &Tag, int nIndex)
{ return SetProp(IPROP_TLIST_MARKTAG, Tag, nIndex);}

inline  BOOL TVbxTList::GetMarkHeight(LONG &Height, int nIndex)
{ return GetProp(IPROP_TLIST_MARKHEIGHT, Height, nIndex);}

inline  BOOL TVbxTList::SetMarkHeight(LONG Height, int nIndex)
{ return SetProp(IPROP_TLIST_MARKHEIGHT, Height, nIndex);}

inline  BOOL TVbxTList::GetMarkWidth(LONG &Width, int nIndex)
{ return GetProp(IPROP_TLIST_MARKWIDTH, Width, nIndex);}

inline  BOOL TVbxTList::SetMarkWidth(LONG Width, int nIndex)
{ return SetProp(IPROP_TLIST_MARKWIDTH, Width, nIndex);}

inline  BOOL TVbxTList::GetAutoExpand(int &Mode)
{ return TVbxControl::GetProp(IPROP_TLIST_AUTOEXPAND, Mode);}

inline  BOOL TVbxTList::SetAutoExpand(int Mode)
{ return TVbxControl::SetProp(IPROP_TLIST_AUTOEXPAND, Mode);}

inline  BOOL TVbxTList::GetTreeLinesStyle(int &Style)
{ return TVbxControl::GetProp(IPROP_TLIST_TREELINESSTYLE, Style);}

inline  BOOL TVbxTList::SetTreeLinesStyle(int Style)
{ return TVbxControl::SetProp(IPROP_TLIST_TREELINESSTYLE, Style);}

inline  BOOL TVbxTList::GetPicInMultiLine(int &Style)
{ return TVbxControl::GetProp(IPROP_TLIST_PICINMULTILINE, Style);}

inline  BOOL TVbxTList::SetPicInMultiLine(int Style)
{ return TVbxControl::SetProp(IPROP_TLIST_PICINMULTILINE, Style);}

inline  BOOL TVbxTList::GetShowCaption(int &Mode)
{ return TVbxControl::GetProp(IPROP_TLIST_SHOWCAPTION, Mode);}

inline  BOOL TVbxTList::SetShowCaption(int Mode)
{ return TVbxControl::SetProp(IPROP_TLIST_SHOWCAPTION, Mode);}

inline  BOOL TVbxTList::GetCaption(string &Text)
{ return TVbxControl::GetProp(IPROP_TLIST_CAPTION, Text);}

inline  BOOL TVbxTList::SetCaption(string &Text)
{ return TVbxControl::SetProp(IPROP_TLIST_CAPTION, Text);}

inline  BOOL TVbxTList::GetShowTitles(int &Mode)
{ return TVbxControl::GetProp(IPROP_TLIST_SHOWTITLES, Mode);}

inline  BOOL TVbxTList::SetShowTitles(int Mode)
{ return TVbxControl::SetProp(IPROP_TLIST_SHOWTITLES, Mode);}

inline  BOOL TVbxTList::GetTitlePicture(HPIC &pict, int nIndex)
{ return SetProp(IPROP_TLIST_TITLEPICTURE, pict, nIndex);}

inline  BOOL TVbxTList::SetTitlePicture(HPIC pict, int nIndex)
{ return SetProp(IPROP_TLIST_TITLEPICTURE, pict, nIndex);}

inline  BOOL TVbxTList::GetTitleText(string &Text, int nIndex)
{ return GetProp(IPROP_TLIST_TITLETEXT, Text, nIndex);}

inline  BOOL TVbxTList::SetTitleText(string &Text, int nIndex)
{ return SetProp(IPROP_TLIST_TITLETEXT, Text, nIndex);}

inline  BOOL TVbxTList::GetTitleVisible(int &Style)
{ return TVbxControl::GetProp(IPROP_TLIST_TITLEVISIBLE, Style);}

inline  BOOL TVbxTList::SetTitleVisible(int Style)
{ return TVbxControl::SetProp(IPROP_TLIST_TITLEVISIBLE, Style);}

inline  BOOL TVbxTList::GetTitleWidth(LONG &Width, int nIndex)
{ return GetProp(IPROP_TLIST_TITLEWIDTH, Width, nIndex);}

inline  BOOL TVbxTList::SetTitleWidth(LONG Width, int nIndex)
{ return SetProp(IPROP_TLIST_TITLEWIDTH, Width, nIndex);}

inline  BOOL TVbxTList::GetTitleHeight(LONG &Height, int nIndex)
{ return GetProp(IPROP_TLIST_TITLEHEIGHT, Height, nIndex);}

inline  BOOL TVbxTList::SetTitleHeight(LONG Height, int nIndex)
{ return SetProp(IPROP_TLIST_TITLEHEIGHT, Height, nIndex);}

inline  BOOL TVbxTList::GetXOffset(LONG &Offset)
{ return TVbxControl::GetProp(IPROP_TLIST_XOFFSET, Offset);}

inline  BOOL TVbxTList::SetXOffset(LONG Offset)
{ return TVbxControl::SetProp(IPROP_TLIST_XOFFSET, Offset);}

inline  BOOL TVbxTList::GetIndent(int &Value, int nIndex)
{ return GetProp(IPROP_TLIST_INDENT, Value, nIndex);}

inline  BOOL TVbxTList::SetIndent(int Value, int nIndex)
{ return SetProp(IPROP_TLIST_INDENT, Value, nIndex);}

inline  BOOL TVbxTList::GetMSOutlineAdd(BOOL &Style)
{ return TVbxControl::GetProp(IPROP_TLIST_MSOUTLINEADD, Style);}

inline  BOOL TVbxTList::SetMSOutlineAdd(BOOL Style)
{ return TVbxControl::SetProp(IPROP_TLIST_MSOUTLINEADD, Style);}

inline  BOOL TVbxTList::GetListCountEx(int &Cnt, int nIndex)
{ return GetProp(IPROP_TLIST_LISTCOUNTEX, Cnt, nIndex);}

inline  BOOL TVbxTList::SetSelectEx(BOOL Mode, int nIndex)
{ return SetProp(IPROP_TLIST_SELECTEX, Mode, nIndex);}

inline  BOOL TVbxTList::SetExpandEx(BOOL Mode, int nIndex)
{ return SetProp(IPROP_TLIST_EXPANDEX, Mode, nIndex);}

inline  BOOL TVbxTList::GetSelItemCount(int &ItemCount)
{ return TVbxControl::GetProp(IPROP_TLIST_SELITEMCOUNT, ItemCount);}

inline  BOOL TVbxTList::GetSelItemIndex(int &ItemIndex, int nIndex)
{ return GetProp(IPROP_TLIST_SELITEMINDEX, ItemIndex, nIndex);}

inline  BOOL TVbxTList::GetItemBM(LONG &ItemBM, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMBM, ItemBM, nIndex);}

inline  BOOL TVbxTList::GetCurrentItemBM(LONG &BookMark, int nIndex)
{ return GetProp(IPROP_TLIST_CURRENTITEMBM, BookMark, nIndex);}

inline  BOOL TVbxTList::SetCurrentItemBM(LONG BookMark, int nIndex)
{ return SetProp(IPROP_TLIST_CURRENTITEMBM, BookMark, nIndex);}

inline  BOOL TVbxTList::GetNewIndex(int &NewIndex)
{ return TVbxControl::GetProp(IPROP_TLIST_NEWINDEX, NewIndex);}

inline  BOOL TVbxTList::GetBackwardCompatibility(BOOL &Mode)
{ return TVbxControl::GetProp(IPROP_TLIST_BACKWARDCOMPATIBILITY, Mode);}

inline  BOOL TVbxTList::SetBackwardCompatibility(BOOL Mode)
{ return TVbxControl::SetProp(IPROP_TLIST_BACKWARDCOMPATIBILITY, Mode);}

inline  BOOL TVbxTList::SetFile(int Mode, int FileHandle)
{ return SetProp(IPROP_TLIST_FILE, Mode, FileHandle);}

inline  BOOL TVbxTList::GetExpandChildren(BOOL &Mode)
{ return TVbxControl::GetProp(IPROP_TLIST_EXPANDCHILDREN, Mode);}

inline  BOOL TVbxTList::SetExpandChildren(BOOL Mode)
{ return TVbxControl::SetProp(IPROP_TLIST_EXPANDCHILDREN, Mode);}

inline  BOOL TVbxTList::GetExpandNewItem(BOOL &Mode, int nIndex)
{ return GetProp(IPROP_TLIST_EXPANDNEWITEM, Mode, nIndex);}

inline  BOOL TVbxTList::SetExpandNewItem(BOOL Mode, int nIndex)
{ return SetProp(IPROP_TLIST_EXPANDNEWITEM, Mode, nIndex);}

inline  BOOL TVbxTList::GetCopyOne(LONG &Data, int nIndex)
{ return GetProp(IPROP_TLIST_COPYONE, Data, nIndex);}

inline  BOOL TVbxTList::SetSaveOne(int FileHandle, int nIndex)
{ return SetProp(IPROP_TLIST_SAVEONE, FileHandle, nIndex);}

inline  BOOL TVbxTList::GetDragModeEx(int &Mode)
{ return TVbxControl::GetProp(IPROP_TLIST_DRAGMODEEX, Mode);}

inline  BOOL TVbxTList::SetDragModeEx(int Mode)
{ return TVbxControl::SetProp(IPROP_TLIST_DRAGMODEEX, Mode);}

inline  BOOL TVbxTList::GetItemSorted(int &SortMode, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMSORTED, SortMode, nIndex);}

inline  BOOL TVbxTList::SetItemSorted(int SortMode, int nIndex)
{ return SetProp(IPROP_TLIST_ITEMSORTED, SortMode, nIndex);}

inline  BOOL TVbxTList::GetItemParentBM(int Item, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMPARENTBM, Item, nIndex);}

inline  BOOL TVbxTList::GetDefMultiLine(BOOL &TextMode, int nIndex)
{ return GetProp(IPROP_TLIST_DEFMULTILINE, TextMode, nIndex);}

inline  BOOL TVbxTList::SetDefMultiLine(BOOL TextMode, int nIndex)
{ return SetProp(IPROP_TLIST_DEFMULTILINE, TextMode, nIndex);}

inline  BOOL TVbxTList::GetItemPMPicType(int &PicType, int nIndex)
{ return GetProp(IPROP_TLIST_ITEMPMPICTYPE, PicType, nIndex);}

inline  BOOL TVbxTList::SetItemPMPicType(int PicType, int nIndex)
{ return SetProp(IPROP_TLIST_ITEMPMPICTYPE, PicType, nIndex);}

inline  BOOL TVbxTList::SetWidthOfTextMin(float Width)
{ return TVbxControl::SetProp(IPROP_TLIST_WIDTHOFTEXTMIN, Width);}

inline  BOOL TVbxTList::GetWidthOfTextMin(float & Width)
{ return TVbxControl::GetProp(IPROP_TLIST_WIDTHOFTEXTMIN, Width);}

inline  BOOL TVbxTList::SetSmartDragDrop(BOOL Mode)
{ return TVbxControl::SetProp(IPROP_TLIST_SMARTDRAGDROP, Mode);}

inline  BOOL TVbxTList::GetSmartDragDrop(BOOL & Mode)
{ return TVbxControl::GetProp(IPROP_TLIST_SMARTDRAGDROP, Mode);}

#endif //TL30P_BC_H

